/******************************************************************************
 * Copyright (C) 2013 Nuvoton(SH) Technology Corp. All rights reserved.
 ******************************************************************************/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include  "uart_nano.h"
#include  "timer_nano.h"
#include  "gpio_nano.h"
 

#define UART_TEST_LENGTH  14

uint32_t g_cnt1, g_cnt2;
__align(4) uint8_t SrcArray[UART_TEST_LENGTH+2];
__align(4) uint8_t DestArray[16];

uint32_t SysTick_Init(uint32_t ticks);

void PDMA_IRQHandler()
{
	int i=0, data, ier, offset;
	
	
	
	if(PDMA2->ISR&PDMA_ISR_WRA_BCR_HALF)
	{
		PDMA2->ISR=PDMA_ISR_WRA_BCR_HALF;	  //崫HALFжϱ־				
		PDMA2->IER = (PDMA2->IER&~0x3C) | PDMA_IER_WRA_BCR_DONE; //ʹDONEж		
		
		for(i=0;i<UART_TEST_LENGTH/2;i++)
		{
		   SrcArray[i]= DestArray[i]; //յΪ 
		}
		PDMA1->BCR = UART_TEST_LENGTH/2;   //ݵĳ
		PDMA1->CSR |=PDMA_CSR_TRIG_EN;	//PDMA1	
		SysTick_Init(12000000);//յ˯ʱ
	}
	else if(PDMA2->ISR&PDMA_ISR_WRA_BCR_DONE)
	{		
		PDMA2->ISR = PDMA_ISR_WRA_BCR_DONE;	  //崫DONEжϱ־
		PDMA2->IER = (PDMA2->IER&~0x3C) | PDMA_IER_WRA_BCR_HALF; //ʹHALFж
		for(i=0;i<UART_TEST_LENGTH/2;i++)
		{
		   SrcArray[i]= DestArray[i + UART_TEST_LENGTH/2]; //յechoȥ 
		}
		
		PDMA1->BCR = UART_TEST_LENGTH/2;    //ݵĳ		
		PDMA1->CSR |=PDMA_CSR_TRIG_EN;	   //PDMA1
		SysTick_Init(12000000);//յ˯ʱ	
	}
#if 1
	else if(PDMA2->ISR&PDMA_ISR_TO)
	{
		PDMA2->ISR=PDMA_ISR_TO;	//峬ʱжϱ־
		data = PDMA2->BUF0;
				
		g_cnt1 = (PDMA2->POINT & 0x0F);//PDMAǷ
		g_cnt2 = (PDMA2->BCR - PDMA2->CBCR);  //յֽ
		ier = PDMA2->IER&0x3C;	 
		
		if(ier == PDMA_ISR_WRA_BCR_HALF)  //ʹHARFж ˵֮ǰDONEж offset=0
			offset = 0;
		else
		{
			offset = UART_TEST_LENGTH/2;
			g_cnt2 -= (UART_TEST_LENGTH/2);
		}		

		if(g_cnt1)
		{
			SysTick_Init(12000000);//1s
			i = 0;
		}
		
		PDMA2->CSR |= PDMA_CSR_SWRST;//λPDMA2
		PDMA2->IER = (PDMA2->IER&~0x3C) | PDMA_IER_WRA_BCR_HALF;
		PDMA2->CSR |=PDMA_CSR_TRIG_EN|PDMA_CSR_CEN;	  //PDMA2UART		

		if(g_cnt1 == 3)		//POINTֵΪ3ʾBUFյ
			g_cnt1 = 2;
		else if(g_cnt1 == 7)  //POINTֵΪ7ʾBUFյ3
			g_cnt1 = 3;
		else if(g_cnt1 > 7)	  //POINTֵ7ʾBUFû
			g_cnt1 = 0;
			
				
		if(g_cnt1)//
		{			
		   memcpy((void*)(DestArray + offset + g_cnt2), (void*)&data, g_cnt1);	 //ղ4ֽڵ		
		}		
		
		if(g_cnt2 || g_cnt1)
		{
			for(i=0;i<g_cnt2 + g_cnt1;i++)
			{
			   SrcArray[i]=DestArray[offset + i] + 0x20;	 //յ+0x20(ʾtimeoutյ)Echoȥ 
			}			
		}
		if(i)
		{
			SrcArray[i] = 0x50;	  //ʾһݵĽβ
			SrcArray[i+1] = 0x51; //ʾһݵĽβ
			PDMA1->BCR	= g_cnt2 + g_cnt1 + 2; //÷͵ݳ
			PDMA1->CSR |=PDMA_CSR_TRIG_EN;
		}
	}
#endif

	
}

/* using CPU clock source */
uint32_t SysTick_Init(uint32_t ticks)
{
  SysTick->LOAD  = (ticks & SysTick_LOAD_RELOAD_Msk) - 1;      /* set reload register */  
  SysTick->VAL   = 0;                                          /* Load the SysTick Counter Value */
  
  //NVIC_SetPriority (SysTick_IRQn, (1<<__NVIC_PRIO_BITS) - 1);  /* set Priority for Systick Interrupt */
  SysTick->CTRL = SysTick->CTRL|(SysTick_CTRL_CLKSOURCE_Msk) | (SysTick_CTRL_ENABLE_Msk);//using cpu clock
  return (0);                                                  /* Function successful */
}

/////////////////////////////////////////////////////////////////////////////////////////
int32_t main(void)							   
{
	UNLOCKREG();	
	CLK->PWRCTL|=CLK_PWRCTL_HIRC_EN;	
	while((CLK->CLKSTATUS& CLK_CLKSTATUS_HIRC_STB) == 0);	
	CLK->CLKSEL0 =CLK->CLKSEL0&( ~CLK_CLKSEL0_HCLK_MASK)|CLK_CLKSEL0_HCLK_HIRC;	
	CLK->CLKSEL1 = CLK->CLKSEL1&(~CLK_CLKSEL1_UART_MASK)|CLK_CLKSEL1_UART_HIRC;
	LOCKREG();
	
	GPIOE->PMD    = GPIO_PMD_PMD6_OUTPUT ;
    /* ʼUART */
	GCR->PB_L_MFP = PB1_MFP_UART0_TX | PB0_MFP_UART0_RX ;
	//MFP_UART0_TO_PORTA();
	CLK->APBCLK  |=  CLK_APBCLK_UART0_EN ;
	UART0->TLCTL   = 0x3003 ;                      //8bit, 1-stop, no parity  
	UART0->BAUD    = 12000000/115200 - 1 ;         //UATR_CLK has been selected 12M  	
	UART0->CTL	|= UART_CTL_DMA_RX_EN|UART_CTL_DMA_TX_EN;  
	
	/* ʹPDMAʱ */
	CLK->AHBCLK  |=  CLK_AHBCLK_DMA_EN ;

	/* ʼPDMA1 for UART0 TX */	
	PDMAGCR->CSR |= PDMAGCR_CSR_CLK1;	 //ʹPDMA1ʱ
	PDMAGCR->PDSSR0 = (PDMAGCR->PDSSR0 & 0xFFFF00FF )  //PDMA1UART0 TX
                   | PDMA_CH1_UART0_TX ;   
	PDMA1->SAR = (uint32_t)SrcArray;   //PDMA1Դַ
	PDMA1->DAR = UART0_BASE;		   //PDMA1Ŀĵַ
	PDMA1->CSR |= PDMA_CSR_SWRST|PDMA_CSR_APB_TWS_8BIT|PDMA_CSR_MEM2IP|PDMA_CSR_DAD_FIX|PDMA_CSR_CEN; 
	PDMA1->BCR	= UART_TEST_LENGTH;		 //PDMAݳ

    /* ʼPDMA2 for UART0 RX */
	PDMAGCR->CSR |= PDMAGCR_CSR_CLK2;	//ʹPDMA2ʱ
	PDMAGCR->PDSSR0 = (PDMAGCR->PDSSR0 & 0xFF00FFFF ) //PDMA2UART0 RX
                   | PDMA_CH2_UART0_RX ;
	PDMA2->SAR = UART0_BASE;			  //PDMA2Դַ
	PDMA2->DAR = (uint32_t)DestArray;	  //PDMA2Ŀĵַ
	PDMA2->CSR |= PDMA_CSR_SWRST|PDMA_CSR_APB_TWS_8BIT|PDMA_CSR_IP2MEM|PDMA_CSR_DAD_WRAP|PDMA_CSR_SAD_FIX|PDMA_CSR_CEN; 
	PDMA2->BCR	= UART_TEST_LENGTH;   //PDMAݳ

	PDMA2->TCR = 10;		     //ʱʱ 1mS
	PDMA2->CSR |= PDMA_CSR_TOEN; //ʹܳʱʱ
	PDMA2->ISR|=PDMA_ISR_TO;	 //峬ʱ־
	PDMA2->IER |= PDMA_IER_TO;	 //ʹܳʱж

	PDMA2->IER |= PDMA_IER_TD;	 //ʹܴж
	PDMA2->IER |= PDMA_IER_WRA_BCR_HALF;
//	NVIC_EnableIRQ(PDMA_IRQn);
	NVIC->ISER[0]  = 1 << PDMA_IRQn ;

	memset(SrcArray, 0, UART_TEST_LENGTH);//UARTݻ
	memset(DestArray, 0, 16);//UARTݻ
	
	PDMA2->CSR |=PDMA_CSR_TRIG_EN|PDMA_CSR_CEN;	  //PDMA2UART

	while(1)
	{			    
		SysTick_Init(12000000); //1sûݾͽ˯
		while((SysTick->CTRL & (1 << 16)) == 0);//1sûݾͽ˯
		
		UART0->CTL |= 0x00000200; 	      //ʹUART
#if 1		
		PE6 = 1;
		UNLOCKREG();
		CLK->PWRCTL |= (CLK_PWRCTL_PWRDOWN_EN );	   /* Set power down bit */
		SCB->SCR |= 0x04;						   /* Sleep Deep */
		LOCKREG();                        	
		__wfi();

		PE6 = 0;			  //ʱLED˸һ
#endif	
	}		
}
