#ifndef  __GPIO_H 
#define  __GPIO_H
#include "nano1xx.h"

/** Define GPIO Pin Data Input/Output. It could be used to control each I/O pin by pin address mapping.
 *  Example 1:
 *  
 *      P00 = 1; 
 *  
 *  It is used to set P0.0 to high;
 *  
 *  Example 2:
 *  
 *      if (P00)
 *          P00 = 0;
 *  
 *  If P0.0 pin status is high, then set P0.0 data output to low.
 */
#define GPIO_PIN_ADDR(port, pin)    (*((volatile uint32_t *)((GPIOBITA_BASE+(0x40*(port))) + ((pin)<<2)))) 
#define PA0             GPIO_PIN_ADDR(0, 0) /*!< Specify P00 Pin Data Input/Output */
#define PA1             GPIO_PIN_ADDR(0, 1) /*!< Specify P01 Pin Data Input/Output */
#define PA2             GPIO_PIN_ADDR(0, 2) /*!< Specify P02 Pin Data Input/Output */
#define PA3             GPIO_PIN_ADDR(0, 3) /*!< Specify P03 Pin Data Input/Output */
#define PA4             GPIO_PIN_ADDR(0, 4) /*!< Specify P04 Pin Data Input/Output */
#define PA5             GPIO_PIN_ADDR(0, 5) /*!< Specify P05 Pin Data Input/Output */
#define PA6             GPIO_PIN_ADDR(0, 6) /*!< Specify P06 Pin Data Input/Output */
#define PA7             GPIO_PIN_ADDR(0, 7) /*!< Specify P07 Pin Data Input/Output */
#define PA8             GPIO_PIN_ADDR(0, 8) /*!< Specify P07 Pin Data Input/Output */
#define PA9             GPIO_PIN_ADDR(0, 9) /*!< Specify P07 Pin Data Input/Output */
#define PA10            GPIO_PIN_ADDR(0, 10) /*!< Specify P07 Pin Data Input/Output */
#define PA11            GPIO_PIN_ADDR(0, 11) /*!< Specify P07 Pin Data Input/Output */
#define PA12            GPIO_PIN_ADDR(0, 12) /*!< Specify P07 Pin Data Input/Output */
#define PA13            GPIO_PIN_ADDR(0, 13) /*!< Specify P07 Pin Data Input/Output */
#define PA14            GPIO_PIN_ADDR(0, 14) /*!< Specify P07 Pin Data Input/Output */
#define PA15            GPIO_PIN_ADDR(0, 15) /*!< Specify P07 Pin Data Input/Output */
#define PB0             GPIO_PIN_ADDR(1, 0) /*!< Specify P10 Pin Data Input/Output */
#define PB1             GPIO_PIN_ADDR(1, 1) /*!< Specify P11 Pin Data Input/Output */
#define PB2             GPIO_PIN_ADDR(1, 2) /*!< Specify P12 Pin Data Input/Output */
#define PB3             GPIO_PIN_ADDR(1, 3) /*!< Specify P13 Pin Data Input/Output */
#define PB4             GPIO_PIN_ADDR(1, 4) /*!< Specify P14 Pin Data Input/Output */
#define PB5             GPIO_PIN_ADDR(1, 5) /*!< Specify P15 Pin Data Input/Output */
#define PB6             GPIO_PIN_ADDR(1, 6) /*!< Specify P16 Pin Data Input/Output */
#define PB7             GPIO_PIN_ADDR(1, 7) /*!< Specify P17 Pin Data Input/Output */
#define PB8             GPIO_PIN_ADDR(1, 8) /*!< Specify P17 Pin Data Input/Output */
#define PB9             GPIO_PIN_ADDR(1, 9) /*!< Specify P17 Pin Data Input/Output */
#define PB10            GPIO_PIN_ADDR(1, 10) /*!< Specify P17 Pin Data Input/Output */
#define PB11            GPIO_PIN_ADDR(1, 11) /*!< Specify P17 Pin Data Input/Output */
#define PB12            GPIO_PIN_ADDR(1, 12) /*!< Specify P17 Pin Data Input/Output */
#define PB13            GPIO_PIN_ADDR(1, 13) /*!< Specify P17 Pin Data Input/Output */
#define PB14            GPIO_PIN_ADDR(1, 14) /*!< Specify P17 Pin Data Input/Output */
#define PB15            GPIO_PIN_ADDR(1, 15) /*!< Specify P17 Pin Data Input/Output */
#define PC0             GPIO_PIN_ADDR(2, 0) /*!< Specify P20 Pin Data Input/Output */
#define PC1             GPIO_PIN_ADDR(2, 1) /*!< Specify P21 Pin Data Input/Output */
#define PC2             GPIO_PIN_ADDR(2, 2) /*!< Specify P22 Pin Data Input/Output */
#define PC3             GPIO_PIN_ADDR(2, 3) /*!< Specify P23 Pin Data Input/Output */
#define PC4             GPIO_PIN_ADDR(2, 4) /*!< Specify P24 Pin Data Input/Output */
#define PC5             GPIO_PIN_ADDR(2, 5) /*!< Specify P25 Pin Data Input/Output */
#define PC6             GPIO_PIN_ADDR(2, 6) /*!< Specify P26 Pin Data Input/Output */
#define PC7             GPIO_PIN_ADDR(2, 7) /*!< Specify P27 Pin Data Input/Output */
#define PC8             GPIO_PIN_ADDR(2, 8) /*!< Specify P27 Pin Data Input/Output */
#define PC9             GPIO_PIN_ADDR(2, 9) /*!< Specify P27 Pin Data Input/Output */
#define PC10            GPIO_PIN_ADDR(2, 10) /*!< Specify P27 Pin Data Input/Output */
#define PC11            GPIO_PIN_ADDR(2, 11) /*!< Specify P27 Pin Data Input/Output */
#define PC12            GPIO_PIN_ADDR(2, 12) /*!< Specify P27 Pin Data Input/Output */
#define PC13            GPIO_PIN_ADDR(2, 13) /*!< Specify P27 Pin Data Input/Output */
#define PC14            GPIO_PIN_ADDR(2, 14) /*!< Specify P27 Pin Data Input/Output */
#define PC15            GPIO_PIN_ADDR(2, 15) /*!< Specify P27 Pin Data Input/Output */
#define PD0             GPIO_PIN_ADDR(3, 0) /*!< Specify P30 Pin Data Input/Output */
#define PD1             GPIO_PIN_ADDR(3, 1) /*!< Specify P31 Pin Data Input/Output */
#define PD2             GPIO_PIN_ADDR(3, 2) /*!< Specify P32 Pin Data Input/Output */
#define PD3             GPIO_PIN_ADDR(3, 3) /*!< Specify P33 Pin Data Input/Output */
#define PD4             GPIO_PIN_ADDR(3, 4) /*!< Specify P34 Pin Data Input/Output */
#define PD5             GPIO_PIN_ADDR(3, 5) /*!< Specify P35 Pin Data Input/Output */
#define PD6             GPIO_PIN_ADDR(3, 6) /*!< Specify P36 Pin Data Input/Output */
#define PD7             GPIO_PIN_ADDR(3, 7) /*!< Specify P37 Pin Data Input/Output */
#define PD8             GPIO_PIN_ADDR(3, 8) /*!< Specify P37 Pin Data Input/Output */
#define PD9             GPIO_PIN_ADDR(3, 9) /*!< Specify P37 Pin Data Input/Output */
#define PD10            GPIO_PIN_ADDR(3, 10) /*!< Specify P37 Pin Data Input/Output */
#define PD11            GPIO_PIN_ADDR(3, 11) /*!< Specify P37 Pin Data Input/Output */
#define PD12            GPIO_PIN_ADDR(3, 12) /*!< Specify P37 Pin Data Input/Output */
#define PD13            GPIO_PIN_ADDR(3, 13) /*!< Specify P37 Pin Data Input/Output */
#define PD14            GPIO_PIN_ADDR(3, 14) /*!< Specify P37 Pin Data Input/Output */
#define PD15            GPIO_PIN_ADDR(3, 15) /*!< Specify P37 Pin Data Input/Output */
#define PE0             GPIO_PIN_ADDR(4, 0) /*!< Specify P40 Pin Data Input/Output */
#define PE1             GPIO_PIN_ADDR(4, 1) /*!< Specify P41 Pin Data Input/Output */
#define PE2             GPIO_PIN_ADDR(4, 2) /*!< Specify P42 Pin Data Input/Output */
#define PE3             GPIO_PIN_ADDR(4, 3) /*!< Specify P43 Pin Data Input/Output */
#define PE4             GPIO_PIN_ADDR(4, 4) /*!< Specify P44 Pin Data Input/Output */
#define PE5             GPIO_PIN_ADDR(4, 5) /*!< Specify P45 Pin Data Input/Output */
#define PE6             GPIO_PIN_ADDR(4, 6) /*!< Specify P46 Pin Data Input/Output */
#define PE7             GPIO_PIN_ADDR(4, 7) /*!< Specify P47 Pin Data Input/Output */
#define PE8             GPIO_PIN_ADDR(4, 8) /*!< Specify P47 Pin Data Input/Output */
#define PE9             GPIO_PIN_ADDR(4, 9) /*!< Specify P47 Pin Data Input/Output */
#define PE10            GPIO_PIN_ADDR(4, 10) /*!< Specify P47 Pin Data Input/Output */
#define PE11            GPIO_PIN_ADDR(4, 11) /*!< Specify P47 Pin Data Input/Output */
#define PE12            GPIO_PIN_ADDR(4, 12) /*!< Specify P47 Pin Data Input/Output */
#define PE13            GPIO_PIN_ADDR(4, 13) /*!< Specify P47 Pin Data Input/Output */
#define PE14            GPIO_PIN_ADDR(4, 14) /*!< Specify P47 Pin Data Input/Output */
#define PE15            GPIO_PIN_ADDR(4, 15) /*!< Specify P47 Pin Data Input/Output */
#define PF0             GPIO_PIN_ADDR(5, 0) /*!< Specify P50 Pin Data Input/Output */
#define PF1             GPIO_PIN_ADDR(5, 1) /*!< Specify P51 Pin Data Input/Output */
#define PF2             GPIO_PIN_ADDR(5, 2) /*!< Specify P52 Pin Data Input/Output */
#define PF3             GPIO_PIN_ADDR(5, 3) /*!< Specify P53 Pin Data Input/Output */
#define PF4             GPIO_PIN_ADDR(5, 4) /*!< Specify P54 Pin Data Input/Output */
#define PF5             GPIO_PIN_ADDR(5, 5) /*!< Specify P55 Pin Data Input/Output */

#endif
